class Black_Hole {

  ////
  float positionX;
  float positionY;
  float size;
  float lastDirectionChange;
  float speedX;
  float speedY;
  float maxSpeed;
  float delay;
  float angle;
  float rotationsPerMinute;
  float clockRotate;
  ////

  //Constructor
  Black_Hole() {

    positionX = width/2;
    positionY = height/2;
    /////////////////////Configurables//
    size = height/6;             //Size
    maxSpeed = 2 * width/600;   //Max movement speed
    delay = 2;                   //Delay between direction changes in seconds
    rotationsPerMinute = 250;        //Rotation speed (negative is counter-clockwise)
    ////////////////////////////////////
  }

  void update() {
    
    //Change direction and speed randomly after every (delay) seconds
    if (millis() - lastDirectionChange > (1000 * delay)) {
      speedX = random(-maxSpeed, maxSpeed);
      speedY = random(-maxSpeed, maxSpeed);
      lastDirectionChange = millis();
    }

    positionX += speedX;
    positionY += speedY;

    //Constrain black hole to an area in the center of the screen
    if (positionX <= width/4 || positionX >= 3*width/4) {
      speedX = -speedX;
    }
    if (positionY <= height/4 || positionY >= 3*height/4) {
      speedY = -speedY;
    }

    //Rotation clock
    if (millis() - clockRotate > 16) {
      clockRotate = millis();
    }
    
    //Rotate black hole (rotationsPerMinute) per minute
    if (clockRotate == millis()){         //Every 16 milliseconds it's rotated 1/3750th (1 minute/16ms = 3750) of a rotation multiplied by the set RPM
      angle -= rotationsPerMinute*(.096);
    }
    if (angle < -100000) {                //Reset angle periodically to stop extremely long values.
      angle = 0;
    }
//    println(angle);
  }


  void display() {
    pushMatrix();
    translate(positionX, positionY);
    rotate(radians(angle));
    image(blackHole, 0, 0, size, size);
    popMatrix();
  }
}

