import processing.core.*; 
import processing.data.*; 
import processing.event.*; 
import processing.opengl.*; 

import java.util.HashMap; 
import java.util.ArrayList; 
import java.io.File; 
import java.io.BufferedReader; 
import java.io.PrintWriter; 
import java.io.InputStream; 
import java.io.OutputStream; 
import java.io.IOException; 

public class Not_Space_Wars_Final extends PApplet {

////////////////Description/////////////////
//Not Space Wars
//By: Stefano D.C., Chris Cadeau & Sida Li
////////////////////////////////////////////

//Array Lists
ArrayList keys= new ArrayList();
ArrayList bullets= new ArrayList();

//Declare Objects
Ship player1;
Ship player2;
Projectile player1Bullets;
Projectile player2Bullets;
background bg;
Black_Hole blackHole1;
Health_Bar health1;
Health_Bar health2;
Ammo_Bar ammo1;
Ammo_Bar ammo2;
Score_Bar score1;
Score_Bar score2;
ParticleSystem Player1_PS, Player2_PS;

//Declare Images
PImage shipImage1;
PImage shipImage2;
PImage bulletImage1;
PImage bulletImage2;
PImage healthImage1;
PImage healthImage2;
PImage blackHole;
////////////////////////////////////////////////////Configurables//
int numberOfRounds = 5;               //Number of points to win
float maxHealth = 100;                //Player health
float projectileDamage = 10;          //Shot Damage
float shotsPerSecond = 20;            //Rate of Fire
int ammoCapacity = 15;                //Ammo Capacity
float reloadsPerSecond = 20;          //Reload Rate
float blackHoleDPS = 100;             //How many times per second the black hole damages a player
float blackHoleDPSMultiplier = 18;    //How much damage the black hole does each time
   //
//////////////////////////////////////////////////////////////////


//Other Variables
float bc = 0;
boolean player1Shoot;
boolean player2Shoot;

public void setup() {
  frameRate(60);
  size(800, 800); //Screen size is scalable
//  smooth(8);
  imageMode(CENTER);
  

  //Load all images
  bulletImage1 = loadImage("Bullet_red.png");
  bulletImage2 = loadImage("Bullet_blue.png");
  healthImage1 = loadImage("Health_red.png");
  healthImage2 = loadImage("Health_blue.png");
  shipImage1 = loadImage("Spaceship_red.png");
  shipImage2 = loadImage("Spaceship_blue.png");
  blackHole = loadImage("Blackhole.png");

  //Controls
  println("// Player 1 controls: A, D, W, S, Space (left, right, up, down, fire)");
  int[] player1ControlsArray = {
    65, 68, 87, 83, 10
  }; 

  println("// Player 2 controls: Left, Right, Up, Down, Enter (left, right, up, down, fire");
  int[] player2ControlsArray = {  
    37, 39, 38, 40, 32
  }; 

  //Initialize Objects
  
  //Players (Controls , Start PositionX , Start PositionY , Player #)
  player1 = new Ship(player1ControlsArray, width/5, height/5, 1);  
  player2 = new Ship(player2ControlsArray, 4*width/5, 4*height/5, 2); 
  //Displays (Player #)
  health1 = new Health_Bar(1);
  health2 = new Health_Bar(2);
  score1 = new Score_Bar(1);
  score2 = new Score_Bar(2);
  ammo1 = new Ammo_Bar(1);
  ammo2 = new Ammo_Bar(2);
  //ParticleSystem
  Player1_PS = new ParticleSystem(1, 200, 400, 400, loadImage("Particle - red.png"));
  Player2_PS = new ParticleSystem(1, 200, 400, 400, loadImage("Particle - blue.png"));
  //Other
  bg = new background();
  blackHole1 = new Black_Hole();
  bullets.add(new Projectile());

  
}

public void draw() {

  ////////////////////////////////////////////UPDATE//
  player1.update();
  player2.update();
  blackHole1.update();

  //
  for (int i = bullets.size()-1; i >= 0; i--) {
    Projectile bulletRef= (Projectile) bullets.get(i);
    bulletRef.update();
  }

  playerCollisions();
  bulletHits();
  removeDeadBullets();

  //////////////////////////////////////////DISPLAY//

  bg.draw();
  health1.display();
  health2.display();
  ammo1.display();
  ammo2.display();
  score1.display();
  score2.display();
  player1.display();
  player2.display();
  blackHole1.display();
//  println(frameRate);
  
  ///////////////////////////////////////PARTICLE//
  
  Player1_PS.X = player1.positionX + random(-20, 20);
  Player1_PS.Y = player1.positionY + random(-20, 20);
  Player1_PS.setSpeed(player1.speedX * -0.5f, player1.speedY * -0.5f);

  if (!player1.movementX && !player1.movementY) {
    Player1_PS.isOn = false;
    //println("Player1:" + Player1_PS.isOn);
  } 
  else {
    Player1_PS.isOn = true;
    //println("Player1:" + Player1_PS.isOn);
  }

  Player2_PS.X = player2.positionX + random(-20, 20);
  Player2_PS.Y = player2.positionY + random(-20, 20);
  Player2_PS.setSpeed(player2.speedX * -0.5f, player2.speedY * -0.5f);

  if (!player2.movementX && !player2.movementY) {
    Player2_PS.isOn = false;
    //println("Player2:" + Player2_PS.isOn);
  } 
  else {
    Player2_PS.isOn = true;
    //println("Player2:" + Player2_PS.isOn);
  }

  Player1_PS.update();
  Player2_PS.update();

  //displays and removes projectiles from the if there are more than 50
  for (int i = bullets.size()-1; i >= 0; i--) {
    Projectile bulletRef= (Projectile) bullets.get(i);
    bulletRef.display();
  }

  if (bullets.size() > 50) {
    bullets.remove(0);
  }
}

///////////////////////////////////////////////Other//

public void playerCollisions() {
  player1.intersect(player2);
  player2.intersect(player1);
}


public void bulletHits() {
  for (int i = bullets.size()-1; i >= 0; i--) {
    Projectile bullet= (Projectile) bullets.get(i);
    if (dist(bullet.positionX, bullet.positionY, player1.positionX, player1.positionY) < player1.size/2 && bullet.playerNumber == 2) {
      player1.onHitByBullet();
      bullets.remove(bullet);
      continue;
    }
    if (dist(bullet.positionX, bullet.positionY, player2.positionX, player2.positionY) < player2.size/2 && bullet.playerNumber == 1) {
      player2.onHitByBullet();
      bullets.remove(bullet);
      continue;
    }
  }
}


//removes bullets that go offscreen or hit the opponent
public void removeDeadBullets() {
  for (int i = bullets.size()-1; i >= 0; i--) {
    Projectile bulletRef= (Projectile) bullets.get(i);
    if (bulletRef.dead) {
      bullets.remove(bulletRef);
      continue;
    }
  }
}

/////////////////////////////////////////////////Key Input//
public void keyPressed() {
  if (!keys.contains(keyCode) && player1.winState == false && player2.winState == false) {
    keys.add(keyCode);
    //    println(keyCode);
  }
}

public void keyReleased() {
  if (keys.contains(keyCode)) {
    keys.remove(keys.indexOf(keyCode));
  }
}

class Ammo_Bar {

  ////  
  float thickness;
  float positionX;
  float positionY;
  float margin;
  float ammo;
  float barEnd;
  int barColor;
  int playerNumber;
  int i;
  ////  

  //Constructor
  Ammo_Bar(int paramPlayerNumber) {
    
    playerNumber = paramPlayerNumber;
    
  }


  public void display() {
    
    rectMode(CENTER);
    barColor = color(188, 174, 66, 255);

    thickness = health1.thickness/2;                                   //Half the thickness of the health bar
    positionY = health1.positionY + health1.thickness/2 + thickness/2; //Positioned just under health bar

    
    if (playerNumber == 1) {
      margin = health1.margin;
      ammo = player2.ammo;                                             //Gets ammo variable from player ship
      positionX = health1.barStart;                                    //Bar starts in line with health bar
      barEnd = ((ammo/ammoCapacity)*100) * (width/400) + margin;       //Bar ends  1/4 of screen width multiplied by % of ammo
      i = 0;
      while (i < barEnd) {                          //Use loop to draw bar to length
        if (ammo >= ammoCapacity - 1) {             //Change color to visually que player to shoot again
          barColor = color(165,255,0, 255);      //
        }                                           //
        noStroke();
        fill(barColor);
        positionX++;
        i++;
        rect(positionX, positionY, 1, thickness);
      }
    }

    if (playerNumber == 2) {                                           //Same as above for other player
      margin = health2.margin;
      ammo = player1.ammo;
      positionX = width - health1.barStart;
      barEnd = ((ammo/ammoCapacity)*100) * (width/400) + margin;
      i = 0;
      while (i< barEnd) {
        if (ammo >= ammoCapacity - 1) {
          barColor = color(165,255,0, 255);
        }
        noStroke();
        fill(barColor);
        positionX--;
        i++;
        rect(positionX, positionY, 1, thickness);
      }
    }
  }
}

class background {

  float starSpeed = 0.05f;
  int starsNum = 3 * height/6;
  stars[] Star = new stars[starsNum];

  ////////////////////////////////////////////////////////////

  class stars {

    float speedX, speedY, X, Y;
    float alaph;

    stars(float iX, float iY, float iAlaph) {

      X = iX;
      Y = iY;
      alaph = iAlaph;
    }

    public void draw() {
      X += speedX;
      Y += speedY;

      alaph = random(0, 190);

      if (X > width) {
        X = 0;
      }

      if (X < 0) {
        X = width;
      }

      if (Y > height) {
        Y = 0;
      }

      if (Y < 0) {
        Y = height;
      }

      noStroke();
      fill(255, alaph);
      ellipse(X, Y, 2, 2);
    }
  }

  ////////////////////////////////////////////////////////////  

  background() {

    for (int i =0;i< starsNum;i++) {

      Star[i] = new stars(random(1, width), random(1, height), 255.0f);
      Star[i].speedX = random(-starSpeed, starSpeed);
      Star[i].speedY = random(-starSpeed, starSpeed);
    }
  }

  public void draw() {

    background(0);

    for (int i =0;i< starsNum;i++) {

      Star[i].draw();
    }
  }
}

class Black_Hole {

  ////
  float positionX;
  float positionY;
  float size;
  float lastDirectionChange;
  float speedX;
  float speedY;
  float maxSpeed;
  float delay;
  float angle;
  float rotationsPerMinute;
  float clockRotate;
  ////

  //Constructor
  Black_Hole() {

    positionX = width/2;
    positionY = height/2;
    /////////////////////Configurables//
    size = height/6;             //Size
    maxSpeed = 2 * width/600;   //Max movement speed
    delay = 2;                   //Delay between direction changes in seconds
    rotationsPerMinute = 250;        //Rotation speed (negative is counter-clockwise)
    ////////////////////////////////////
  }

  public void update() {
    
    //Change direction and speed randomly after every (delay) seconds
    if (millis() - lastDirectionChange > (1000 * delay)) {
      speedX = random(-maxSpeed, maxSpeed);
      speedY = random(-maxSpeed, maxSpeed);
      lastDirectionChange = millis();
    }

    positionX += speedX;
    positionY += speedY;

    //Constrain black hole to an area in the center of the screen
    if (positionX <= width/4 || positionX >= 3*width/4) {
      speedX = -speedX;
    }
    if (positionY <= height/4 || positionY >= 3*height/4) {
      speedY = -speedY;
    }

    //Rotation clock
    if (millis() - clockRotate > 16) {
      clockRotate = millis();
    }
    
    //Rotate black hole (rotationsPerMinute) per minute
    if (clockRotate == millis()){         //Every 16 milliseconds it's rotated 1/3750th (1 minute/16ms = 3750) of a rotation multiplied by the set RPM
      angle -= rotationsPerMinute*(.096f);
    }
    if (angle < -100000) {                //Reset angle periodically to stop extremely long values.
      angle = 0;
    }
//    println(angle);
  }


  public void display() {
    pushMatrix();
    translate(positionX, positionY);
    rotate(radians(angle));
    image(blackHole, 0, 0, size, size);
    popMatrix();
  }
}

class Health_Bar {

  ////
  int playerNumber;
  int i;
  float lifePoints;
  float thickness;
  float margin;
  float positionX;
  float positionY;
  float barStart;
  float barEnd;
  ////

  //Constructor
  Health_Bar(int paramPlayerNumber) {
    playerNumber = paramPlayerNumber;
  }

  public void display() {
    
    rectMode(CENTER);

    margin = 1 * (height/100);                   //Offset amount from screen borders (percent of screen size)
    thickness = 1.5f * (height/100);              //Thickness of bar (percent of screen size)
    positionY = margin + thickness/2;            //Y-Position of bar

    if (playerNumber == 1) {
      lifePoints = player1.lifePoints;                                 //Get life points from player ship
      barStart = margin + thickness/2;                                 //PositionX of bar at min health
      positionX = barStart;
      barEnd = ((lifePoints/maxHealth) * 100) * (width/300)+ margin;   //Bar ends  1/3 of screen width multiplied by % of health
      i = 0;
      while (i < barEnd) {                                             //Use loop to draw bar to length
        noStroke();
        positionX++;
        i++;
        image(healthImage1, positionX, positionY, 1, thickness);       //draws health bar using image
        fill(color(255, random(255)));                                                                //Draws noise within health bar
        rect(positionX, positionY + (random(-thickness/2, thickness/2)), thickness/15, thickness/15); //
      }
    }

    if (playerNumber == 2) {                     //Same as above for other player
      lifePoints = player2.lifePoints;
      barStart = margin + thickness/2;
      positionX = width - (barStart);
      barEnd = ((lifePoints/maxHealth) * 100) * (width/300)+ margin;
      i = 0;
      while (i < barEnd) {
        noStroke();
        positionX--;
        i++;
        fill(color(255, random(255)));
        rect(positionX, positionY + (random(-thickness/2, thickness/2)), thickness/15, thickness/15);
        image(healthImage2, positionX, positionY, 1, thickness);
      }
    }
  }
}


class ParticleSystem {

  // BRUST = 1, EXPLOTION = 2;
  int MODE = 1;
  int maxNum = 25;
  float speedX, speedY;
  float X, Y;
  PImage ParticleImg;
  Particle[] particles;
  boolean isOn = true;

  ///////////////////////////////////////////////////////////

  class Particle {

    float X, Y;
    float speedX, speedY;
    int Color;
    boolean isDead = true;
    float lifetime = random(40, 60);
    float alaph = 255;
    PImage Pimg;

    Particle(float iX, float iY, float ispdX, float ispdY, PImage img) {

      X = iX;
      Y = iY;
      speedX = ispdX;
      speedY = ispdY;
      Pimg = img;
      Pimg.resize(5, 5);
    }

    public void refresh() {

      lifetime = random(30, 50);
      isDead = false;
      alaph = 255;
    }

    public void update() {

      if (!isDead) {


        noStroke();
        fill(Color, alaph);

        X += speedX;
        Y += speedY;
        alaph -= 3;

        lifetime -= 1;

        if (lifetime <= 0) {

          isDead = true;
        }

        tint(255, alaph); 
        image(Pimg, X, Y);
        tint(255, 255);
      }
    }
  }

  ////////////////////////////////////////////////////////////

  ParticleSystem(int iMODE, int iMax, float iX, float iY, PImage img) {

    MODE = iMODE;
    maxNum = iMax;
    ParticleImg = img;

    X = iX;
    Y = iY;


    particles = new Particle[maxNum];

    if (MODE == 1) {

      for (int i=0;i< maxNum;i++) {

        particles[i] = new Particle(X, Y, 0, 0, ParticleImg);
      }
    } 
    else if (MODE == 2) {

      isOn = false;
      for (int i = 0; i < maxNum ;i++) {
        particles[i] = new Particle(X, Y, random(-3, 3), random(-3, 3), ParticleImg);
        particles[i].isDead = false;
      }
    }
  }

  public void reset() {

    if (MODE == 2) {

      isOn = false;
      for (int i = 0; i < maxNum ;i++) {
        particles[i] = new Particle(X, Y, random(-3, 3), random(-3, 3), ParticleImg);
        particles[i].isDead = false;
      }
    }
  }

  public void setSpeed(float ispdX, float ispdY) {

    speedX = ispdX;
    speedY = ispdY;
  }

  public void update() {


    if (MODE == 1) {

      for (int i=0;i< maxNum;i++) {

        if (particles[i].isDead && isOn) {

          particles[i].refresh();
          particles[i].X = X;
          particles[i].Y = Y;

          particles[i].speedX = speedX + random(-2, 2);
          particles[i].speedY = speedY + random(-2, 2);
        } 

        particles[i].update();
      }
    } 
    else if (MODE == 2 && isOn) {
      for (int i=0;i< maxNum;i++) {
        if (!particles[i].isDead) {

          particles[i].update();
        }
      }
    }
  }
}

class Projectile {
  
  ////
  float projectileSpeed;
  float projectileWidth;
  float projectileLength;
  float angle;
  float displayAngle;
  float speedX;
  float speedY;
  float positionX;
  float positionY;
  int playerNumber;
  boolean dead;
  ////

  //Constuctor
  Projectile() {
    
    //size and speed (% of screen height)
    projectileWidth = .6f * height/100;  
    projectileLength = 2 * height/100;
    projectileSpeed = 1 *width/100;
    
    
    //Use respective position and angle depending on which ship is shooting
    if (player1Shoot == true) {
      positionX = player1.positionX;
      positionY = player1.positionY;
      angle = player1.angle;
      playerNumber = 1;
      displayAngle = -player1.angle;
    }
    else if (player2Shoot == true) {
      positionX = player2.positionX;
      positionY = player2.positionY;
      angle = player2.angle;
      playerNumber = 2;
      displayAngle = -player2.angle;
    }

    //Determine bullet X and Y speed using player angle
    speedX = (cos(angle)) * projectileSpeed;      
    speedY = (sin(angle)) * projectileSpeed;
  }

  public void update() {

    //Move Projectiles
    positionX += speedX;
    positionY -= speedY;
    destroyIfOffScreen();
  }

  public void destroyIfOffScreen() {
    if (positionX < 0 || positionX > width || positionY < 0 || positionY > height) {
      dead=true;
    }
  }

  public void display() {
    if (playerNumber == 1) {
      pushMatrix();
      translate(positionX, positionY);
      rotate(displayAngle);
      image(bulletImage1,0,0,projectileLength,projectileWidth);
      popMatrix();
    }
    if (playerNumber == 2) {
      pushMatrix();
      translate(positionX, positionY);
      rotate(displayAngle);
      image(bulletImage2,0,0,projectileLength,projectileWidth);
      popMatrix();
    }
  }
}

class Score_Bar {

  ////
  float thickness;
  float positionY;
  float positionX;
  float positionX2;
  float positionX3;
  float score;
  int playerNumber;
  int i;
  int barColor;
  ////

  //Constructor
  Score_Bar(int paramPlayerNumber) {
    playerNumber = paramPlayerNumber;
  }

  public void display() {
    barColor = color(234, 197, 92);
    //    barColor = color(255);
    thickness = (1 * height/100);              //Size of markers
    positionY = health1.margin;                //Y-Position of markers

    rectMode(CENTER);
    noStroke();
    fill(barColor);

    if (playerNumber == 1) {

      score = player2.score;                               //Get score from player ship

      i = 0;
      positionX = health1.margin + thickness;              //X-Position of first marker
      while (i < score) {                                  //Loop draws a marker for each point the player has
        noStroke();
        fill(barColor);
        positionX += 2*thickness;
        rect(positionX, positionY, thickness, thickness);
        i++;
      }

      i = 0;
      positionX = health1.margin + thickness;
      while (i < numberOfRounds) {                         //Loop draws (number of rounds) empty markers
        stroke(195);
        strokeWeight(2);
        fill(0, 0);
        positionX += 2*thickness;
        rect(positionX, positionY, thickness, thickness);
        i++;
      }
    }

    if (playerNumber == 2) {                               //Same as above for other player

      score = player1.score;

      i = 0;
      positionX = width - health2.margin - thickness;
      while (i < score) {
        noStroke();
        fill(barColor);
        positionX -= 2*thickness;
        rect(positionX, positionY, thickness, thickness);
        i++;
      }

      i = 0;
      positionX = width - health2.margin - thickness;
      while (i < numberOfRounds) {
        stroke(195);
        strokeWeight(2);
        fill(0, 0);
        positionX -= 2*thickness;
        rect(positionX, positionY, thickness, thickness);
        i++;
      }
    }
  }
}

class Ship {

  ////
  int playerNumber;
  float positionX;
  float positionY;
  float respawnX;
  float respawnY;
  float size;
  float speedX;
  float speedY;
  float accel;
  float deccel;
  float maxSpeed;
  float minSpeed;
  boolean movementX;
  boolean movementY;
  boolean firing;
  boolean winState;
  float clockFire;
  float clockReload;
  float clockCollision;
  float clockWinState;
  ////
  float opponentX;
  float opponentY;
  float distX;
  float distY;
  float angle;
  ////
  float lifePoints;
  int ammo;
  float score;
  ////
  int leftKey;
  int rightKey;
  int upKey;
  int downKey;
  int fireKey;
  ////
  float winStateTextSize = width/10;
  
  
  
  //Constructor
  Ship(int[] keyControlsArray, float paramPositionX, float paramPositionY, int paramPlayerNumber) {

    leftKey = keyControlsArray[0];
    rightKey = keyControlsArray[1];
    upKey = keyControlsArray[2];
    downKey = keyControlsArray[3];
    fireKey = keyControlsArray[4];

    playerNumber = paramPlayerNumber;
    positionX = paramPositionX;      
    positionY = paramPositionY;
    respawnX = paramPositionX;
    respawnY = paramPositionY;
    lifePoints = maxHealth;
    ammo = ammoCapacity;
    score = 0;

    //////////////////////////////////Configurables//
    size = height/15;              //Ship size
    minSpeed = 0;                  //Min speed
    maxSpeed = 5 * width/600;    //Max speed
    accel =  .50f * width/600;     //Accelleration modifier
    deccel = .90f;                  //Deccelleration modifier
    /////////////////////////////////////////////////
  }

  public void update() {
  
    //Respawn player if killed
    if (lifePoints <= 0) {
      score++;
      positionX = respawnX;
      positionY = respawnY;
      lifePoints = maxHealth;
    }

     
    //Halt player movement and control if round limit is reached
    if (score == numberOfRounds) {
      player1.score = 0;
      player1.positionX = player1.respawnX;
      player1.positionY = player1.respawnY;
      player1.lifePoints = maxHealth;
      player2.score = 0;
      player2.positionX = player2.respawnX;
      player2.positionY = player2.respawnY;
      player2.lifePoints = maxHealth;
      winState = true;
      clockWinState = millis();
    }
    
    //Reset game after delay
    if (millis() - clockWinState > 5000 && winState == true){
      player1.score = 0;
      player1.positionX = player1.respawnX;
      player1.positionY = player1.respawnY;
      player1.lifePoints = maxHealth;
      player2.score = 0;
      player2.positionX = player2.respawnX;
      player2.positionY = player2.respawnY;
      player2.lifePoints = maxHealth;
      player1.speedX = 0;
      player1.speedY = 0;
      player2.speedX = 0;
      player2.speedY = 0;
      winState = false;
      clockWinState = millis();
      }
      
          
    
    
    
    ////////////////////////////////////////////////////////////////////////Movement//

    movementX = false;
    movementY = false;

    //Move Ship
    if (keys.contains(rightKey)) {
      speedX += accel;
      movementX = true;
    }
    else if (keys.contains(leftKey)) {
      speedX -= accel;
      movementX = true;
    }
    if (keys.contains(upKey)) {
      speedY -= accel;
      movementY = true;
    }
    else if (keys.contains(downKey)) {
      speedY += accel;
      movementY = true;
    }

    //Deccellerate Ship Speed to Minimum
    if (movementX == false) {
      speedX *= deccel;
    }
    if (movementY == false) {
      speedY *= deccel;
    }

    //Constrain Speed
    if (speedX >= maxSpeed) {
      speedX = maxSpeed;
    }
    if (speedX <= -maxSpeed) {
      speedX = -maxSpeed;
    }
    if (speedY >= maxSpeed) {
      speedY = maxSpeed;
    }
    if (speedY <= -maxSpeed) {
      speedY = -maxSpeed;
    }

    //Move Players
    positionX += speedX;
    positionY += speedY;

    // constrain player position so that it doesn't go offscreen
    positionX=constrain(positionX, 20, width-20);
    positionY=constrain(positionY, 20, height-20);
    
    

    /////////////////////////////////////////////////////////////////////////Direction// 

    //Decide which player to aim towards
    if (playerNumber == 1 && frameCount>1) {
      opponentX = player2.positionX;
      opponentY = player2.positionY;
    }
    else if (playerNumber == 2 && frameCount>1) {
      opponentX = player1.positionX;
      opponentY = player1.positionY;
    }

    //Decide angle of player
    distX = dist(positionX, 0, opponentX, 0);
    distY = dist(0, positionY, 0, opponentY);
    angle = atan(distY/distX);

    //Correct each quadrant around ship to get angle clockwise from the positive X direction rather than switching to nearest X origin (hack solution) 
    if (positionX > opponentX && positionY >= opponentY) {
      angle = PI/2 - angle + PI/2;
    }
    if (positionX >= opponentX && positionY < opponentY) {
      angle = angle + PI;
    }
    if (positionX < opponentX && positionY < opponentY) {
      angle = PI/2 - angle + 3*PI/2;
    }

    ///////////////////////////////////////////////////////////////////////Clocks//
  
    //Fire Rate  
    if (millis() - clockFire > 1000/shotsPerSecond) {
      clockFire = millis();
    }
    //Reload Rate
    if (millis() - clockReload > 1000/reloadsPerSecond) {
      clockReload = millis();
    }
    //Black Hole Damage Rate
    if (millis() - clockCollision > 1000/blackHoleDPS) {
      clockCollision = millis();
    }


    ///////////////////////////////////////////////////////////////////////Fire Weapon//



    firing = false;

    if (keys.contains(fireKey)) {
      firing = true;
      if (clockFire == millis() && ammo > 0) {  //Limit fire rate
        bullets.add(new Projectile());          //Create projectile
        ammo--;                                 //Update ammo
      }
    }
    if (clockReload == millis() && ammo < ammoCapacity && firing == false) { //Reload at limited rate when the player is not shooting
      ammo++;
    }

    //Tell projectile which player is shooting
    player1Shoot = false;    
    player2Shoot = false;
    if (playerNumber == 1) {
      player1Shoot = true;
    }
    if (playerNumber == 2) {
      player2Shoot = true;
    }
  }

  public void display() {
    
    if (winState == true){
        textSize(winStateTextSize);
        if (playerNumber == 1){
          fill(0,0,255);
          text("BLUE WINS!", width/2-(winStateTextSize*2),height/2);
        }
        if (playerNumber == 2){
          fill(255,0,0);
          text("RED WINS!",width/2-(winStateTextSize*2),height/2);
        }
      }
      
    //draw each unique sprite
    if (playerNumber == 1) {
      pushMatrix();
      translate(positionX, positionY);
      rotate(-angle);
      image(shipImage1, 0, 0, size, size);
      popMatrix();
    }

    if (playerNumber == 2) {
      pushMatrix();
      translate(positionX, positionY);
      rotate(-angle);
      image(shipImage2, 0, 0, size, size);
      popMatrix();
    }
  }

  public void intersect(Ship b) {
    float distance = dist(positionX, positionY, b.positionX, b.positionY); // Calculate distance
    if (distance < size/2 ) { //Check for collision
      lifePoints -= 5; //Damage ship
      println("Collision!");
    }
    float distance2 = dist(positionX, positionY, blackHole1.positionX, blackHole1.positionY); // Calculate distance
    if (distance2 < blackHole1.size/2 && clockCollision == millis()) { //Check for collision
      //Damage ship 0-100% of black hole DpS depending on how close to center the player is
      lifePoints -= blackHoleDPSMultiplier * (((blackHole1.size/2)-(distance2/2))/100); 
    }
  }

  public void onHitByBullet() {
    //Update health if player is hit by shot
    if (lifePoints > 0) {
      lifePoints -= projectileDamage;
    }
  }
}

  static public void main(String[] passedArgs) {
    String[] appletArgs = new String[] { "Not_Space_Wars_Final" };
    if (passedArgs != null) {
      PApplet.main(concat(appletArgs, passedArgs));
    } else {
      PApplet.main(appletArgs);
    }
  }
}
