////////////////Description/////////////////
//Not Space Wars
//By: Stefano D.C., Chris Cadeau & Sida Li
////////////////////////////////////////////

//Array Lists
ArrayList keys= new ArrayList();
ArrayList bullets= new ArrayList();

//Declare Objects
Ship player1;
Ship player2;
Projectile player1Bullets;
Projectile player2Bullets;
background bg;
Black_Hole blackHole1;
Health_Bar health1;
Health_Bar health2;
Ammo_Bar ammo1;
Ammo_Bar ammo2;
Score_Bar score1;
Score_Bar score2;
ParticleSystem Player1_PS, Player2_PS;

//Declare Images
PImage shipImage1;
PImage shipImage2;
PImage bulletImage1;
PImage bulletImage2;
PImage healthImage1;
PImage healthImage2;
PImage blackHole;
////////////////////////////////////////////////////Configurables//
int numberOfRounds = 5;               //Number of points to win
float maxHealth = 100;                //Player health
float projectileDamage = 10;          //Shot Damage
float shotsPerSecond = 20;            //Rate of Fire
int ammoCapacity = 15;                //Ammo Capacity
float reloadsPerSecond = 20;          //Reload Rate
float blackHoleDPS = 100;             //How many times per second the black hole damages a player
float blackHoleDPSMultiplier = 18;    //How much damage the black hole does each time
   //
//////////////////////////////////////////////////////////////////


//Other Variables
float bc = 0;
boolean player1Shoot;
boolean player2Shoot;

void setup() {
  frameRate(60);
  size(800, 800); //Screen size is scalable
//  smooth(8);
  imageMode(CENTER);
  

  //Load all images
  bulletImage1 = loadImage("Bullet_red.png");
  bulletImage2 = loadImage("Bullet_blue.png");
  healthImage1 = loadImage("Health_red.png");
  healthImage2 = loadImage("Health_blue.png");
  shipImage1 = loadImage("Spaceship_red.png");
  shipImage2 = loadImage("Spaceship_blue.png");
  blackHole = loadImage("Blackhole.png");

  //Controls
  println("// Player 1 controls: A, D, W, S, Space (left, right, up, down, fire)");
  int[] player1ControlsArray = {
    65, 68, 87, 83, 10
  }; 

  println("// Player 2 controls: Left, Right, Up, Down, Enter (left, right, up, down, fire");
  int[] player2ControlsArray = {  
    37, 39, 38, 40, 32
  }; 

  //Initialize Objects
  
  //Players (Controls , Start PositionX , Start PositionY , Player #)
  player1 = new Ship(player1ControlsArray, width/5, height/5, 1);  
  player2 = new Ship(player2ControlsArray, 4*width/5, 4*height/5, 2); 
  //Displays (Player #)
  health1 = new Health_Bar(1);
  health2 = new Health_Bar(2);
  score1 = new Score_Bar(1);
  score2 = new Score_Bar(2);
  ammo1 = new Ammo_Bar(1);
  ammo2 = new Ammo_Bar(2);
  //ParticleSystem
  Player1_PS = new ParticleSystem(1, 200, 400, 400, loadImage("Particle - red.png"));
  Player2_PS = new ParticleSystem(1, 200, 400, 400, loadImage("Particle - blue.png"));
  //Other
  bg = new background();
  blackHole1 = new Black_Hole();
  bullets.add(new Projectile());

  
}

void draw() {

  ////////////////////////////////////////////UPDATE//
  player1.update();
  player2.update();
  blackHole1.update();

  //
  for (int i = bullets.size()-1; i >= 0; i--) {
    Projectile bulletRef= (Projectile) bullets.get(i);
    bulletRef.update();
  }

  playerCollisions();
  bulletHits();
  removeDeadBullets();

  //////////////////////////////////////////DISPLAY//

  bg.draw();
  health1.display();
  health2.display();
  ammo1.display();
  ammo2.display();
  score1.display();
  score2.display();
  player1.display();
  player2.display();
  blackHole1.display();
//  println(frameRate);
  
  ///////////////////////////////////////PARTICLE//
  
  Player1_PS.X = player1.positionX + random(-20, 20);
  Player1_PS.Y = player1.positionY + random(-20, 20);
  Player1_PS.setSpeed(player1.speedX * -0.5, player1.speedY * -0.5);

  if (!player1.movementX && !player1.movementY) {
    Player1_PS.isOn = false;
    //println("Player1:" + Player1_PS.isOn);
  } 
  else {
    Player1_PS.isOn = true;
    //println("Player1:" + Player1_PS.isOn);
  }

  Player2_PS.X = player2.positionX + random(-20, 20);
  Player2_PS.Y = player2.positionY + random(-20, 20);
  Player2_PS.setSpeed(player2.speedX * -0.5, player2.speedY * -0.5);

  if (!player2.movementX && !player2.movementY) {
    Player2_PS.isOn = false;
    //println("Player2:" + Player2_PS.isOn);
  } 
  else {
    Player2_PS.isOn = true;
    //println("Player2:" + Player2_PS.isOn);
  }

  Player1_PS.update();
  Player2_PS.update();

  //displays and removes projectiles from the if there are more than 50
  for (int i = bullets.size()-1; i >= 0; i--) {
    Projectile bulletRef= (Projectile) bullets.get(i);
    bulletRef.display();
  }

  if (bullets.size() > 50) {
    bullets.remove(0);
  }
}

///////////////////////////////////////////////Other//

void playerCollisions() {
  player1.intersect(player2);
  player2.intersect(player1);
}


void bulletHits() {
  for (int i = bullets.size()-1; i >= 0; i--) {
    Projectile bullet= (Projectile) bullets.get(i);
    if (dist(bullet.positionX, bullet.positionY, player1.positionX, player1.positionY) < player1.size/2 && bullet.playerNumber == 2) {
      player1.onHitByBullet();
      bullets.remove(bullet);
      continue;
    }
    if (dist(bullet.positionX, bullet.positionY, player2.positionX, player2.positionY) < player2.size/2 && bullet.playerNumber == 1) {
      player2.onHitByBullet();
      bullets.remove(bullet);
      continue;
    }
  }
}


//removes bullets that go offscreen or hit the opponent
void removeDeadBullets() {
  for (int i = bullets.size()-1; i >= 0; i--) {
    Projectile bulletRef= (Projectile) bullets.get(i);
    if (bulletRef.dead) {
      bullets.remove(bulletRef);
      continue;
    }
  }
}

/////////////////////////////////////////////////Key Input//
void keyPressed() {
  if (!keys.contains(keyCode) && player1.winState == false && player2.winState == false) {
    keys.add(keyCode);
    //    println(keyCode);
  }
}

void keyReleased() {
  if (keys.contains(keyCode)) {
    keys.remove(keys.indexOf(keyCode));
  }
}

