class ParticleSystem {

  // BRUST = 1, EXPLOTION = 2;
  int MODE = 1;
  int maxNum = 25;
  float speedX, speedY;
  float X, Y;
  PImage ParticleImg;
  Particle[] particles;
  boolean isOn = true;

  ///////////////////////////////////////////////////////////

  class Particle {

    float X, Y;
    float speedX, speedY;
    color Color;
    boolean isDead = true;
    float lifetime = random(40, 60);
    float alaph = 255;
    PImage Pimg;

    Particle(float iX, float iY, float ispdX, float ispdY, PImage img) {

      X = iX;
      Y = iY;
      speedX = ispdX;
      speedY = ispdY;
      Pimg = img;
      Pimg.resize(5, 5);
    }

    void refresh() {

      lifetime = random(30, 50);
      isDead = false;
      alaph = 255;
    }

    void update() {

      if (!isDead) {


        noStroke();
        fill(Color, alaph);

        X += speedX;
        Y += speedY;
        alaph -= 3;

        lifetime -= 1;

        if (lifetime <= 0) {

          isDead = true;
        }

        tint(255, alaph); 
        image(Pimg, X, Y);
        tint(255, 255);
      }
    }
  }

  ////////////////////////////////////////////////////////////

  ParticleSystem(int iMODE, int iMax, float iX, float iY, PImage img) {

    MODE = iMODE;
    maxNum = iMax;
    ParticleImg = img;

    X = iX;
    Y = iY;


    particles = new Particle[maxNum];

    if (MODE == 1) {

      for (int i=0;i< maxNum;i++) {

        particles[i] = new Particle(X, Y, 0, 0, ParticleImg);
      }
    } 
    else if (MODE == 2) {

      isOn = false;
      for (int i = 0; i < maxNum ;i++) {
        particles[i] = new Particle(X, Y, random(-3, 3), random(-3, 3), ParticleImg);
        particles[i].isDead = false;
      }
    }
  }

  void reset() {

    if (MODE == 2) {

      isOn = false;
      for (int i = 0; i < maxNum ;i++) {
        particles[i] = new Particle(X, Y, random(-3, 3), random(-3, 3), ParticleImg);
        particles[i].isDead = false;
      }
    }
  }

  void setSpeed(float ispdX, float ispdY) {

    speedX = ispdX;
    speedY = ispdY;
  }

  void update() {


    if (MODE == 1) {

      for (int i=0;i< maxNum;i++) {

        if (particles[i].isDead && isOn) {

          particles[i].refresh();
          particles[i].X = X;
          particles[i].Y = Y;

          particles[i].speedX = speedX + random(-2, 2);
          particles[i].speedY = speedY + random(-2, 2);
        } 

        particles[i].update();
      }
    } 
    else if (MODE == 2 && isOn) {
      for (int i=0;i< maxNum;i++) {
        if (!particles[i].isDead) {

          particles[i].update();
        }
      }
    }
  }
}

