class Projectile {
  
  ////
  float projectileSpeed;
  float projectileWidth;
  float projectileLength;
  float angle;
  float displayAngle;
  float speedX;
  float speedY;
  float positionX;
  float positionY;
  int playerNumber;
  boolean dead;
  ////

  //Constuctor
  Projectile() {
    
    //size and speed (% of screen height)
    projectileWidth = .6 * height/100;  
    projectileLength = 2 * height/100;
    projectileSpeed = 1 *width/100;
    
    
    //Use respective position and angle depending on which ship is shooting
    if (player1Shoot == true) {
      positionX = player1.positionX;
      positionY = player1.positionY;
      angle = player1.angle;
      playerNumber = 1;
      displayAngle = -player1.angle;
    }
    else if (player2Shoot == true) {
      positionX = player2.positionX;
      positionY = player2.positionY;
      angle = player2.angle;
      playerNumber = 2;
      displayAngle = -player2.angle;
    }

    //Determine bullet X and Y speed using player angle
    speedX = (cos(angle)) * projectileSpeed;      
    speedY = (sin(angle)) * projectileSpeed;
  }

  void update() {

    //Move Projectiles
    positionX += speedX;
    positionY -= speedY;
    destroyIfOffScreen();
  }

  void destroyIfOffScreen() {
    if (positionX < 0 || positionX > width || positionY < 0 || positionY > height) {
      dead=true;
    }
  }

  void display() {
    if (playerNumber == 1) {
      pushMatrix();
      translate(positionX, positionY);
      rotate(displayAngle);
      image(bulletImage1,0,0,projectileLength,projectileWidth);
      popMatrix();
    }
    if (playerNumber == 2) {
      pushMatrix();
      translate(positionX, positionY);
      rotate(displayAngle);
      image(bulletImage2,0,0,projectileLength,projectileWidth);
      popMatrix();
    }
  }
}

