class Ship {

  ////
  int playerNumber;
  float positionX;
  float positionY;
  float respawnX;
  float respawnY;
  float size;
  float speedX;
  float speedY;
  float accel;
  float deccel;
  float maxSpeed;
  float minSpeed;
  boolean movementX;
  boolean movementY;
  boolean firing;
  boolean winState;
  float clockFire;
  float clockReload;
  float clockCollision;
  float clockWinState;
  ////
  float opponentX;
  float opponentY;
  float distX;
  float distY;
  float angle;
  ////
  float lifePoints;
  int ammo;
  float score;
  ////
  int leftKey;
  int rightKey;
  int upKey;
  int downKey;
  int fireKey;
  ////
  float winStateTextSize = width/10;
  
  
  
  //Constructor
  Ship(int[] keyControlsArray, float paramPositionX, float paramPositionY, int paramPlayerNumber) {

    leftKey = keyControlsArray[0];
    rightKey = keyControlsArray[1];
    upKey = keyControlsArray[2];
    downKey = keyControlsArray[3];
    fireKey = keyControlsArray[4];

    playerNumber = paramPlayerNumber;
    positionX = paramPositionX;      
    positionY = paramPositionY;
    respawnX = paramPositionX;
    respawnY = paramPositionY;
    lifePoints = maxHealth;
    ammo = ammoCapacity;
    score = 0;

    //////////////////////////////////Configurables//
    size = height/15;              //Ship size
    minSpeed = 0;                  //Min speed
    maxSpeed = 5 * width/600;    //Max speed
    accel =  .50 * width/600;     //Accelleration modifier
    deccel = .90;                  //Deccelleration modifier
    /////////////////////////////////////////////////
  }

  void update() {
  
    //Respawn player if killed
    if (lifePoints <= 0) {
      score++;
      positionX = respawnX;
      positionY = respawnY;
      lifePoints = maxHealth;
    }

     
    //Halt player movement and control if round limit is reached
    if (score == numberOfRounds) {
      player1.score = 0;
      player1.positionX = player1.respawnX;
      player1.positionY = player1.respawnY;
      player1.lifePoints = maxHealth;
      player2.score = 0;
      player2.positionX = player2.respawnX;
      player2.positionY = player2.respawnY;
      player2.lifePoints = maxHealth;
      winState = true;
      clockWinState = millis();
    }
    
    //Reset game after delay
    if (millis() - clockWinState > 5000 && winState == true){
      player1.score = 0;
      player1.positionX = player1.respawnX;
      player1.positionY = player1.respawnY;
      player1.lifePoints = maxHealth;
      player2.score = 0;
      player2.positionX = player2.respawnX;
      player2.positionY = player2.respawnY;
      player2.lifePoints = maxHealth;
      player1.speedX = 0;
      player1.speedY = 0;
      player2.speedX = 0;
      player2.speedY = 0;
      winState = false;
      clockWinState = millis();
      }
      
          
    
    
    
    ////////////////////////////////////////////////////////////////////////Movement//

    movementX = false;
    movementY = false;

    //Move Ship
    if (keys.contains(rightKey)) {
      speedX += accel;
      movementX = true;
    }
    else if (keys.contains(leftKey)) {
      speedX -= accel;
      movementX = true;
    }
    if (keys.contains(upKey)) {
      speedY -= accel;
      movementY = true;
    }
    else if (keys.contains(downKey)) {
      speedY += accel;
      movementY = true;
    }

    //Deccellerate Ship Speed to Minimum
    if (movementX == false) {
      speedX *= deccel;
    }
    if (movementY == false) {
      speedY *= deccel;
    }

    //Constrain Speed
    if (speedX >= maxSpeed) {
      speedX = maxSpeed;
    }
    if (speedX <= -maxSpeed) {
      speedX = -maxSpeed;
    }
    if (speedY >= maxSpeed) {
      speedY = maxSpeed;
    }
    if (speedY <= -maxSpeed) {
      speedY = -maxSpeed;
    }

    //Move Players
    positionX += speedX;
    positionY += speedY;

    // constrain player position so that it doesn't go offscreen
    positionX=constrain(positionX, 20, width-20);
    positionY=constrain(positionY, 20, height-20);
    
    

    /////////////////////////////////////////////////////////////////////////Direction// 

    //Decide which player to aim towards
    if (playerNumber == 1 && frameCount>1) {
      opponentX = player2.positionX;
      opponentY = player2.positionY;
    }
    else if (playerNumber == 2 && frameCount>1) {
      opponentX = player1.positionX;
      opponentY = player1.positionY;
    }

    //Decide angle of player
    distX = dist(positionX, 0, opponentX, 0);
    distY = dist(0, positionY, 0, opponentY);
    angle = atan(distY/distX);

    //Correct each quadrant around ship to get angle clockwise from the positive X direction rather than switching to nearest X origin (hack solution) 
    if (positionX > opponentX && positionY >= opponentY) {
      angle = PI/2 - angle + PI/2;
    }
    if (positionX >= opponentX && positionY < opponentY) {
      angle = angle + PI;
    }
    if (positionX < opponentX && positionY < opponentY) {
      angle = PI/2 - angle + 3*PI/2;
    }

    ///////////////////////////////////////////////////////////////////////Clocks//
  
    //Fire Rate  
    if (millis() - clockFire > 1000/shotsPerSecond) {
      clockFire = millis();
    }
    //Reload Rate
    if (millis() - clockReload > 1000/reloadsPerSecond) {
      clockReload = millis();
    }
    //Black Hole Damage Rate
    if (millis() - clockCollision > 1000/blackHoleDPS) {
      clockCollision = millis();
    }


    ///////////////////////////////////////////////////////////////////////Fire Weapon//



    firing = false;

    if (keys.contains(fireKey)) {
      firing = true;
      if (clockFire == millis() && ammo > 0) {  //Limit fire rate
        bullets.add(new Projectile());          //Create projectile
        ammo--;                                 //Update ammo
      }
    }
    if (clockReload == millis() && ammo < ammoCapacity && firing == false) { //Reload at limited rate when the player is not shooting
      ammo++;
    }

    //Tell projectile which player is shooting
    player1Shoot = false;    
    player2Shoot = false;
    if (playerNumber == 1) {
      player1Shoot = true;
    }
    if (playerNumber == 2) {
      player2Shoot = true;
    }
  }

  void display() {
    
    if (winState == true){
        textSize(winStateTextSize);
        if (playerNumber == 1){
          fill(0,0,255);
          text("BLUE WINS!", width/2-(winStateTextSize*2),height/2);
        }
        if (playerNumber == 2){
          fill(255,0,0);
          text("RED WINS!",width/2-(winStateTextSize*2),height/2);
        }
      }
      
    //draw each unique sprite
    if (playerNumber == 1) {
      pushMatrix();
      translate(positionX, positionY);
      rotate(-angle);
      image(shipImage1, 0, 0, size, size);
      popMatrix();
    }

    if (playerNumber == 2) {
      pushMatrix();
      translate(positionX, positionY);
      rotate(-angle);
      image(shipImage2, 0, 0, size, size);
      popMatrix();
    }
  }

  void intersect(Ship b) {
    float distance = dist(positionX, positionY, b.positionX, b.positionY); // Calculate distance
    if (distance < size/2 ) { //Check for collision
      lifePoints -= 5; //Damage ship
      println("Collision!");
    }
    float distance2 = dist(positionX, positionY, blackHole1.positionX, blackHole1.positionY); // Calculate distance
    if (distance2 < blackHole1.size/2 && clockCollision == millis()) { //Check for collision
      //Damage ship 0-100% of black hole DpS depending on how close to center the player is
      lifePoints -= blackHoleDPSMultiplier * (((blackHole1.size/2)-(distance2/2))/100); 
    }
  }

  void onHitByBullet() {
    //Update health if player is hit by shot
    if (lifePoints > 0) {
      lifePoints -= projectileDamage;
    }
  }
}

